using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;
using GameLibrary;

namespace Solid_Color
{
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        Random rand;
        SpriteFont font;
        Texture2D shapeImage;
        List<Sprite> shapes;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            TargetElapsedTime = TimeSpan.FromTicks(333333);
        }

        protected override void Initialize()
        {
            base.Initialize();
        }

        protected override void LoadContent()
        {
            rand = new Random();
            spriteBatch = new SpriteBatch(GraphicsDevice);
            font = Content.Load<SpriteFont>("WascoSans");

            shapeImage = Content.Load<Texture2D>("box");

            Sprite box1 = new Sprite(Content, spriteBatch);
            box1.image = shapeImage;
            box1.position = new Vector2(rand.Next(0, 200), rand.Next(0, 380));
            box1.velocityLinear = new Vector2(4.0f, 3.0f);
            box1.origin = new Vector2(64, 64);
            box1.SetAnimation(null);
            
            Sprite box2 = new Sprite(Content, spriteBatch);
            box2.image = shapeImage;
            box2.position = new Vector2(rand.Next(200, 400), rand.Next(0, 380));
            box2.velocityLinear = new Vector2(4.0f, 3.0f);
            box2.origin = new Vector2(64, 64);
            box2.SetAnimation(null);

            Sprite box3 = new Sprite(Content, spriteBatch);
            box3.image = shapeImage;
            box3.position = new Vector2(rand.Next(400, 600), rand.Next(0, 380));
            box3.velocityLinear = new Vector2(4.0f, 3.0f);
            box3.origin = new Vector2(64, 64);
            box3.SetAnimation(null);
                        
            shapes = new List<Sprite>();
            shapes.Add(box1);
            shapes.Add(box2);
            shapes.Add(box3);
        }

        protected override void Update(GameTime gameTime)
        {
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            foreach (Sprite spr in shapes)
            {
                spr.Move();

                if (spr.position.X < 0 || spr.position.X > 800 ||
                    spr.position.Y < 0 || spr.position.Y > 480)
                {
                    spr.SetAnimation(new SolidColor(
                        new Color(rand.Next(255), rand.Next(255), rand.Next(255))));

                    if (spr.position.X < -64 || spr.position.X > 800+64)
                        spr.velocityLinear.X *= -1;

                    if (spr.position.Y < -64 || spr.position.Y > 480+64)
                        spr.velocityLinear.Y *= -1;
                }
                else
                    spr.SetAnimation(new SolidColor(Color.White));

            }

            base.Update(gameTime);
        }

        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.Black);
            spriteBatch.Begin();

            foreach (Sprite spr in shapes)
            {
                spr.Animate();
                spr.Draw();
            }

            spriteBatch.DrawString(font, "Solid Color Demo", new Vector2(0, 0), Color.White);

            spriteBatch.End();
            base.Draw(gameTime);
        }
    }

}
