using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;
using GameLibrary;

namespace Black_Hole_Game
{
    class GameOverModule : IGameModule
    {
        Game1 game;
        Random rand;
        Label lblTitle;
        Button btnReturn;

        public GameOverModule(Game1 game)
        {
            this.game = game;
            rand = new Random();
        }

        public void Reset()
        {
        }

        public void LoadContent(ContentManager content)
        {
            lblTitle = new Label(content, game.spriteBatch, game.bigfont);
            lblTitle.text = "GAME OVER!";
            Vector2 size = game.font.MeasureString(lblTitle.text);
            lblTitle.position = new Vector2(400-size.X, 200);

            btnReturn = new Button(content, game.spriteBatch, game.guifont);
            btnReturn.text = "Return";
            btnReturn.position = new Vector2(400, 430);
            btnReturn.scaleV = new Vector2(2.0f, 1.0f);
        }

        public void Update(TouchLocation touch, GameTime gameTime)
        {
            btnReturn.Update(touch);
            if (btnReturn.Tapped)
                game.gameState = Game1.GameState.TITLE;
        }

        public void Draw(GameTime gameTime)
        {
            lblTitle.Draw();
            btnReturn.Draw();
        }
    }
}
