using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;
using GameLibrary;

namespace Black_Hole_Game
{
    class OptionsModule : IGameModule
    {
        Game1 game;
        Random rand;
        Label lblTitle;
        Button btnReturn;
        Button btnAudio;

        public OptionsModule(Game1 game)
        {
            this.game = game;
            rand = new Random();
        }

        public void Reset()
        {
        }

        public void LoadContent(ContentManager content)
        {
            lblTitle = new Label(content, game.spriteBatch, game.bigfont);
            lblTitle.text = "Options Screen";
            Vector2 size = game.font.MeasureString(lblTitle.text);
            lblTitle.position = new Vector2(400-size.X, 10);

            btnAudio = new Button(game.Content, game.spriteBatch, game.guifont);
            btnAudio.text = "";
            btnAudio.position = new Vector2(400, 240);
            btnAudio.scaleV = new Vector2(4.0f, 1.0f);

            btnReturn = new Button(content, game.spriteBatch, game.guifont);
            btnReturn.text = "Return";
            btnReturn.position = new Vector2(400, 430);
            btnReturn.scaleV = new Vector2(3.0f, 1.2f);
        }

        public void Update(TouchLocation touch, GameTime gameTime)
        {
            if (game.globalAudio)
                btnAudio.text = "Turn Sound OFF";
            else
                btnAudio.text = "Turn Sound ON";

            btnAudio.Update(touch);

            if (btnAudio.Tapped)
            {
                game.globalAudio = !game.globalAudio;
            }

            btnReturn.Update(touch);
            if (btnReturn.Tapped)
                game.gameState = Game1.GameState.TITLE;
        }

        public void Draw(GameTime gameTime)
        {
            lblTitle.Draw();
            btnAudio.Draw();
            btnReturn.Draw();
        }
    }
}
